/* 
 * semaforo
 * Juan Galaz
 * seta43.duckdns.org
 * seta43.blogspot.com 
 * simulIDE  2021
*/

#define F_CPU 16000000L

#include <avr/io.h>          
#include <util/delay.h>


//__________________ tiempos Semaforo____
#define  srojo 5		//S
#define  samarillo 2000	//mS
#define  sverde 4			//S
#define  sparpadeo 500		//mS



void PORTB_ON(unsigned char x)
{
 unsigned char n,temp;
	n=1;
	n=n<<x;
	temp=PINB | n;
	PORTB=temp;	
}

void PORTB_OFF(unsigned char x)
{
  unsigned char n,temp;
	n=1;
	n=n<<x;
	n=~n;
	temp=PINB & n;
	PORTB=temp;
}


void delaySec(int sec)
{
	while(sec>0)
	{
	 sec--;
	 _delay_ms(1000);
	}
}

void semaforoRojo(void)
{	
	PORTB_OFF(1);
	PORTB_OFF(2);
	PORTB_ON(3);
}

void semaforoAmarillo(void)
{	
	PORTB_OFF(1);
	PORTB_ON(2);
	PORTB_OFF(3);
}

void semaforoVerde(void)
{	
	PORTB_ON(1);
	PORTB_OFF(2);
	PORTB_OFF(3);
}

void peatonVerde(void)
{
	PORTB_ON(4);
	PORTB_OFF(5);
}

void peatonRojo(void)
{
	PORTB_OFF(4);
	PORTB_ON(5);
}

void peatonApagado(void)
{
	PORTB_OFF(4);
	PORTB_OFF(5);	
}

void peatonParpadeo(int z)
{
	while(z>0)
		{
			z--;		
			 peatonVerde();
			_delay_ms(sparpadeo);
			 peatonApagado();
			_delay_ms(sparpadeo);
		}
	peatonApagado();
	_delay_ms(sparpadeo);
}


int main (void)
{
	PORTB=0x00;	
	DDRB=0xff; 	// puerto B como salida (output)
	
	while(1)
	{	
		semaforoAmarillo();
		_delay_ms(samarillo);
		semaforoRojo();
		_delay_ms(samarillo);
		peatonVerde();
		delaySec(srojo);		
		peatonParpadeo(6);
		peatonRojo();
		semaforoVerde();
		delaySec(sverde);	
	}
 return(0);
}